/* ǡΥإåγƥǡ (for script)
 * 12/29 2003
 * shige
 * sndstat.c
 *
 * $Id: sndstat.c,v 1.4 2005-01-05 19:52:42+09 shige Exp $
 */
/* sndstat [option] ([infile])
 *   [option]: 
 *     -au: au/wav/aiff 
 *     -ch: channel 
 *     -sr: sapmling rate (aiff ʤ double)
 *     -bs: 1 block size
 *     -bl: block 
 *     -dl: data Ĺ
 *     -hl: data  offset
 *     -bp: bitpersample
 *     -fm: format code (aiff ʤ)
 */
/* -vl: peek volume 
 * -vl[n]: [n] channel  peek volume ([n]==0 ==> -vl Ʊ)
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "common.h"

enum {OP_AU=1,OP_CH,OP_SR,OP_BS,OP_BL,OP_DL,OP_HL,OP_BP,OP_FM,
      OP_VL,OP_UNKNOWN};

#define Maxchannel 10

int main(int argc,char *argv[]);
int getarg(int argc,char **argv,FILE **infile,int *ch);
void usage(int ret);

int main(int argc,char *argv[])
{
    SNDheader snd;
    FILE *infile;
    int format,mode,ch,ret;
    long int lret;
    double level,maxl[Maxchannel];
    
    if((mode=getarg(argc,argv,&infile,&ch))<=0){
	usage(mode); return -mode;
    }
    if((format=getSNDheader(infile,&snd))<0 || format==E_UNKNOWN){
	fprintf(stderr,"Error: In getSNDheader(). (%d)\n",format);
	return 1;
    }
    switch(mode){
    case OP_AU:
	if(format==E_AU) printf("au\n");
	else if(format==E_WAV) printf("wav\n");
	else if(format==E_AIFF) printf("aiff\n");
	else{ printf("unknown\n"); return 2; }
	break;
    case OP_CH:
	if((ret=SNDchannels(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%d\n",ret);
	break;
    case OP_SR:
	if(format==E_AU) printf("%ld\n",snd.au.smplrate);
	else if(format==E_WAV) printf("%ld\n",snd.wav.smplrate);
	else if(format==E_AIFF) printf("%f\n",snd.aiff.smplrate.x);
	else{ printf("unknown\n"); return 2; }
	break;
    case OP_BS:
	if((ret=SNDblocksize(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%d\n",ret);
	break;
    case OP_BL:
	if((lret=SNDblocks(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%ld\n",lret);
	break;
    case OP_DL:
	if((lret=SNDdatalen(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%ld\n",lret);
	break;
    case OP_HL:
	if((lret=SNDhlen(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%ld\n",lret);
	break;
    case OP_BP:
	if((ret=SNDbitpersmpl(&snd,format))<0){ printf("unknown\n"); return 2; }
	else printf("%d\n",ret);
	break;
    case OP_FM:
	if(format==E_AU) printf("%ld\n",snd.au.fmcode);
	else if(format==E_WAV) printf("%d\n",snd.wav.fmcode);
	else if(format==E_AIFF) ;
	else{ printf("unknown\n"); return 2; }
	break;
    case OP_VL:
	if(ch==0){
	    if((level=SNDgetmaxlevel(infile,&snd,format))<0.0) return 3;
	    else printf("%f\n",level);
	}
	else if(ch>SNDchannels(&snd,format)) return 3;
	else if((level=SNDgetmaxlevelChannel(infile,&snd,format,maxl))<0.0)
	  return 3;
	else printf("%f\n",maxl[ch-1]);
	break;
    default:
	break;
    }
    return 0;
}

int getarg(int argc,char **argv,FILE **infile,int *ch)
{
    int mode=-10;

    *infile=stdin;

    while(--argc>0){
	if(**(++argv)=='-'){
	    if(!strcmp(*argv,"-au")) mode=OP_AU;
	    else if(!strcmp(*argv,"-ch")) mode=OP_CH;
	    else if(!strcmp(*argv,"-sr")) mode=OP_SR;
	    else if(!strcmp(*argv,"-bs")) mode=OP_BS;
	    else if(!strcmp(*argv,"-bl")) mode=OP_BL;
	    else if(!strcmp(*argv,"-dl")) mode=OP_DL;
	    else if(!strcmp(*argv,"-hl")) mode=OP_HL;
	    else if(!strcmp(*argv,"-bp")) mode=OP_BP;
	    else if(!strcmp(*argv,"-fm")) mode=OP_FM;
	    else if(!strncmp(*argv,"-vl",3)){ 
		mode=OP_VL;
		if(strlen(*argv)==3) *ch=0;
		else if((*ch=atoi(*argv+3))<0) return -10;
	    }
	    else if(!strcmp(*argv,"-h") ||!strcmp(*argv,"-H")
		    ||!strcmp(*argv,"-?")) return 0; 
	    else if(!strcmp(*argv,"-")) break;
	    else{ fprintf(stderr,"Unknown option. (%s)\n",*argv); return -1; }
	}
	else break;
    }

    if(argc>1) return -2;
    else if(argc<1) return mode;
    else if(!strcmp(*argv,"-") ||(*infile=fopen(*argv,"r"))!=NULL) return mode;
    else{
	fprintf(stderr,"File [%s] open error.\n",*argv);
	return -3;
    }
}

void usage(int ret)
{
    char *mess[]={
	"Usage: sndstat [option] ([infile])",
	"   [infile]: ϥե (ά: ɸ)",
	"   [option] ϰʲΤ:",
	"     -au: au/wav/aiff",
	"     -ch: channel ",
	"     -sr: sapmling rate (aiff ʤ double)",
	"     -bs: 1 block size",
	"     -bl: block ",
	"     -dl: data Ĺ",
	"     -hl: data  offset",
	"     -bp: bitpersample",
	"     -fm: format code (aiff ʤ)",
	"     -vl([n]): volume level κ (0~1 δ֤μ¿)",
	"               [n] դ [n] channel  volume level Τ",
	"               (-vl0  -vl Ʊ)",
	" ",
	" [1] ϥե '-' ꤷ礫άɸϤˤʤ롣",
	NULL
    };
    int j;

    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
